
<?php

include './conexion.php';



if(isset($_FILES["file"])) {
    $file = $_FILES["file"];

    // Verificar si se subió correctamente el archivo
    if ($file["error"] === UPLOAD_ERR_OK) {
        $filename = $file["tmp_name"];

        // Leer el contenido del archivo
        $fileContent = file_get_contents($filename);

        // Aquí puedes procesar el contenido del archivo según tus necesidades
        // Por ejemplo, puedes realizar una operación de base de datos o cualquier otra operación.

        // Enviar una respuesta al cliente
       // echo "Archivo cargado y procesado correctamente.";


function separaDias($dias){
    $valor=null;
    switch($dias){
        case 'L'; $valor=1; break;
        case 'M'; $valor=1; break;
        case 'Mi'; $valor=1; break;
        case 'J'; $valor=1; break;
        case 'V'; $valor=1; break;
        case 'S'; $valor=1; break;
        case 'D'; $valor=1; break;
        default :$valor=9; break;
    }
    return $valor;
}

function regresaDias($dias){
    $valor=null;
    switch($dias){
        case '0'; $valor='L'; break;
        case '1'; $valor='M'; break;
        case '2'; $valor='Mi'; break;
        case '3'; $valor='J'; break;
        case '4'; $valor='V'; break;
        case '5'; $valor='S'; break;
        case '6'; $valor='D'; break;

    }
    return $valor;
}

?>
        <style>
.scrollable-div {
            width: calc(100% - 20px); /* Set your desired width */
            height: 650px; /* Set your desired height */
            overflow-y: scroll; /* Enable vertical scrolling */
            border: 1px solid #ccc; /* Optional: Add border for visualization */
            /*padding: 10px; /* Optional: Add padding for content */
        }


</style>

<!-- Agregar el modal de carga -->
<div class="modal" id="cargandoModal" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-body">
        <!--<p style="text-align:center;"><img src="./img/loading2.gif" alt="Cargando"><img> Cargando información, favor de esperar..</p>-->
      </div>
    </div>
  </div>
</div>

        <div class="panel panel-primary">
          <div class="panel-heading">
            
          </div>
          <div class="panel-body">
          <div class="scrollable-div">
    
    <?php
    require_once './Classes/PHPExcel.php';
    //$archivo = "Lista.xlsx";
    $archivo = $filename;
    $inputFileType = PHPExcel_IOFactory::identify($archivo);
    $objReader = PHPExcel_IOFactory::createReader($inputFileType);
    $objPHPExcel = $objReader->load($archivo);
    $sheet = $objPHPExcel->getSheet(0); 
    $highestRow = $sheet->getHighestRow(); 
    $highestColumn = $sheet->getHighestColumn();
    $in = 0;
    
    // Array para almacenar los datos
    $dataArray = [];
for ($row = 2; $row <= $highestRow; $row++) {
  $dataArray[] = [
        'ubicacion' => $sheet->getCell("A".$row)->getValue(),
        'supervisor' => $sheet->getCell("B".$row)->getValue(),
        'lugar' => $sheet->getCell("I".$row)->getValue(),
        'numEmp' => $sheet->getCell("D".$row)->getValue(),
        'periodo' => $sheet->getCell("E".$row)->getValue(),
        'nombre' => $sheet->getCell("F".$row)->getValue(),
        'sueldo' => $sheet->getCell("G".$row)->getValue(),
        'turno' => $sheet->getCell("H".$row)->getValue(),
        'observacion' => $sheet->getCell("J".$row)->getValue(),
        'mes' => $sheet->getCell("K".$row)->getValue(),
        'anio' => $sheet->getCell("L".$row)->getValue()
    ];
}

?>
    
    <p class="statusMsgx"></p>  
    <table  style='border:1px'>
        <thead>
            <tr>
                
                
                <th></th>
                <th></th>
                <th></th>
                <th></th>
                <th></th>
                <th></th>
                <th colspan='4'>Descansos</th>
                <th colspan='7'>Asistencia</th>
                <th></th>
                <th></th>
                <th></th>

            </tr>
            <tr>
                <th rowspan="2"></th>
                <th rowspan="2" style="width:80px;">Ubicacion</th>
                <th rowspan="2">Supervisor</th>
                <th>Lugar de Trabajo</th>
                <th>Num. Empl.</th>
                <th>Periodo</th>
                <th>Nombre Completo</th>
                <th>Sueldo Dato</th>
                <th>Turno</th>
                <th>D1</th>
                <th>D2</th>
                <th>D3</th>
                <th>D4</th>
                <th>V</th>
                <th>S</th>
                <th>D</th>
                <th>L</th>
                <th>M</th>
                <th>Mi</th>
                <th>J</th>
                <th>Observaciones</th>
                <th>Mes</th>
                <th>Año</th>
            </tr>
        </thead>
        <tbody>
            <?php
            $num = 0;
            $valores=null;
            // Imprimir filas ordenadas
            foreach ($dataArray as $data) {
                $num++;

                

                echo "<tr>";
                echo "<th scope='row'>" . $num . "</th>";
                echo "<td> <input style='width: 80px;' disabled name='ubicacion' type='text' value='".$data['ubicacion']."'/></td>";
                echo "<td> <input disabled name='supervisor' type='text' value='" . $data['supervisor'] . "'/></td>";
                echo "<td> <input  style='width: 300px;'disabled name='lugar' type='text' value='" . $data['lugar'] . "'/></td>";
                echo "<td> <input style='width: 60px; text-align:right;'disabled name='numEmp' type='text' value='" . $data['numEmp'] . "'/></td>";
                echo "<td> <input style='width: 50px;'disabled name='periodo' type='text'value='" . $data['periodo'] . "'/></td>";
                echo "<td> <input style='width: 350px;'disabled name='nombre' type='text' value='" . str_replace(',', '', $data['nombre']) . "'/></td>";
                echo "<td> <input style='width: 80px;text-align:right;'disabled name='sueldo' type='text' value='" . $data['sueldo'] . "'/></td>";
                echo "<td> <input style='width: 300px;' disabled name='turno' type='text' style='text-align:right;' value='" . $data['turno']."'/></td>";

                $L=substr($data['turno'],0,1);
                $M=substr($data['turno'],1,1);
                $Mi=substr($data['turno'],2,1)."i";
                $J=substr($data['turno'],3,1);
                $V=substr($data['turno'],4,1);
                $S=substr($data['turno'],5,1);
                $D=substr($data['turno'],6,1);
                $posiciones = [];
                $posicion = strpos($data['turno'], '_'); // Encuentra la primera aparición

                // Recorrer el string para encontrar todas las posiciones
                while ($posicion !== false) {
                    // Almacenar la posición actual
                    $posiciones[] = $posicion;
                    
                    // Buscar la siguiente aparición
                    $posicion = strpos($data['turno'], '_', $posicion + 1);
                }
                // Recorrer las posiciones encontradas y aplicar las condiciones
                $d1=null;
                $d2=null;
                $d3=null;
                $d4=null;

                
                /*foreach ($posiciones as $index => $pos) {
                $x=1;
                    //$descansos=null;    
                    if ($index == 0) {
                        $descansos.="L";
                    } elseif ($index == 1) {
                        $descansos.="M";
                    } elseif ($index == 2) {
                        $descansos.="Mi";
                    } elseif ($index == 3) {
                        $descansos.="J";
                    } elseif ($index == 4) {
                        $descansos.="V";
                    } elseif ($index == 5) {
                        $descansos.="S";
                    } elseif ($index == 6) {
                        $descansos.="D";
                    }

                    /*switch($x){
                        case '1': $d1=$descansos;break;
                        case '2': $d2=$descansos;break;
                        case '3': $d3=$descansos;break;
                        case '4': $d4=$descansos;break;
                    }
                    $x++;

                }*/
                $desc=count($posiciones);
                if($desc==1){
                    $d1=$posiciones[0];
                } else if($desc==2){
                    $d1=$posiciones[0];
                    $d2=$posiciones[1];
                }else if($desc==3){
                    $d1=$posiciones[0];
                    $d2=$posiciones[1];
                    $d3=$posiciones[2];
                }else if($desc==4){
                    $d1=$posiciones[0];
                    $d2=$posiciones[1];
                    $d3=$posiciones[2];
                    $d4=$posiciones[3];
                }
                //echo "<td> " .implode(", ",$posiciones). "</td>";
                /*echo "<td> " .count($posiciones). "</td>";
                $descansos=null;    */
                echo "<td> <input style='width: 20px;' disabled name='D1' type='text' style='text-align:right;' value='"  .regresaDias($d1). "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='D2' type='text' style='text-align:right;' value='"  .regresaDias($d2). "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='D3' type='text' style='text-align:right;' value='"  .regresaDias($d3). "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='D4' type='text' style='text-align:right;' value='"  .regresaDias($d4). "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno1' type='text' style='text-align:right;' value='" . separaDias($V) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno2' type='text' style='text-align:right;' value='" . separaDias($S) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno3' type='text' style='text-align:right;' value='" . separaDias($D) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno4' type='text' style='text-align:right;' value='" . separaDias($L) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno5' type='text' style='text-align:right;' value='" . separaDias($M) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno6' type='text' style='text-align:right;' value='" . separaDias($Mi) . "'/></td>";
                echo "<td> <input style='width: 20px;' disabled name='turno7' type='text' style='text-align:right;' value='" . separaDias($J) . "'/></td>";

                echo "<td> <input style='width: 300px;' disabled name='observaciones' type='text' value='" . $data['observacion'] . "'/></td>";
                echo "<td> <input style='width: 50px;'disabled name='mes' type='text' style='text-align:right;' value='" . $data['mes'] . "'/></td>";
                echo "<td> <input style='width: 50px;'disabled name='anio' type='text' style='text-align:right;' value='" . $data['anio'] . "'/></td>";
                echo "</tr>";

                                     
              }
              
            }
            ?>
        </tbody>
    </table>
    
    </div>
    
        <?php //echo $sql.substr($valores, 0, -1).";";?>
        <table>
        <tr>
                <?php
                ?>
                <td>
                <button type="button" class="btn btn-default" style="width: 120px;color:white;background-color: rgb(120, 160, 248);border-color:rgb(120, 160, 248);" onclick="javascript:window.location.reload()">Cancelar</button>
                <!--<button type="button" class="btn btn-default" onclick="javascript:window.location.href='./cargaGasolina.php'">Cancelar</button>-->
                <?php
                //if($in==0){
                    ?>
                  <!--  <button disabled type="button" id="btnEnviar" class="btn btn-primary" >Enviar</button>-->
                    <?php                    
                //} else {
                    ?>
                    <button type="button" id="btnEnviar" class="btn btn-primary" onclick="guardar()">Enviar</button>
                    <?php
                //}
                ?>
                
                </td>
                
            </tr> 
            </table>
      </div>	
    
    </body>


        
        <?php
    } else {
        // Si hay un error al subir el archivo, enviar un mensaje de error
        echo "Error uploading file.";
    }

?>

<script>
function guardar() {
    // Obtenemos los valores de las filas de la tabla
    var dataToSend = [];
    $('table tbody tr').each(function() {
        var row = {};
        $(this).find('input[type="text"], input[type="number"]').each(function() {
            row[$(this).attr('name')] = $(this).val();
        });
        dataToSend.push(row);
    });



    // Realizamos la solicitud AJAX
    $.ajax({
        type: "POST",
        url: "guardarPrenomina.php", // Aquí debes poner la URL de tu script PHP para guardar los datos
        data: { data: dataToSend },
        success: function(msg) {
          var response = JSON.parse(msg);      
            if (response.respuesta === 'ok') {
                $('.statusMsgx').html('<span style="color:green;">Datos guardados.</span>');
                $('#btnEnviar').prop("disabled", true);
                alert("Datos guardados");
                $('#cargandoModal').modal('hide');
            } else if (response.respuesta === 'err1') {
                $('.statusMsgx').html('<span style="color:red;">Ocurrió un problema, intente de nuevo.</span>');
            } else if (response.respuesta === 'errx') {
                $('.statusMsgx').html('<span style="color:red;">No hay datos que guardar.</span>');
            } else {
                $('.statusMsgx').html('*' + response.respuesta + '*');
            }
        },
        error: function(xhr, status, error) {
            console.error(xhr.responseText);
            $('.statusMsgx').html('<span style="color:red;">Error en la solicitud AJAX.</span>');
        },
        complete: function() {
            $('.submitBtn').removeAttr("disabled");
            $('.modal-body').css('opacity', '');
        }
    });
}




</script>


